import numpy as np
import matplotlib.pyplot as plt 
import matplotlib
from matplotlib.ticker import NullFormatter
from PIL import Image

anz_zeichen = len(Hello_World)

im = Image.open('./illustration_DeborahMoldawski.jpg')
x_max=5334
y_max=4000

params = {
    'figure.figsize'    : [17.34,13]
}
matplotlib.rcParams.update(params)
plt.style.use('dark_background')
nullfmt = NullFormatter() 

fig, ax = plt.subplots()
ax.yaxis.set_major_formatter(nullfmt)
ax.xaxis.set_major_formatter(nullfmt)

ax.imshow(im)

# define the colormap
cmap = plt.cm.Blues
zeichen_colors = cmap(np.linspace(0,1,2*anz_zeichen))

textstr0=r'$Zeiger \, und \, Arrays'+'$'
textstr1=r'$\vec{v}=v_i \Rightarrow'+'$'
textstr2=r'$char \,\, satz[23]'+'$'
props = dict(boxstyle='round', facecolor='black', alpha=0.95)
props1 = dict(boxstyle='square', facecolor='black', alpha=0.65)
ax.text(2750, 1500, textstr0, fontsize=37, verticalalignment='top', horizontalalignment='center', bbox=props)
ax.text(2200, 2320, textstr1, fontsize=37, verticalalignment='top', horizontalalignment='right', bbox=props)
ax.text(2500, 2520, textstr2, fontsize=35, verticalalignment='top', horizontalalignment='left', bbox=props)

r=y_max/2
r1=r*0.65
i=0
for addresse in Hello_World_Adressen:
    props2 = dict(boxstyle='round', facecolor=zeichen_colors[anz_zeichen+i], alpha=0.95)
    
    phi = - i*1.8*np.pi/len(Hello_World) - np.pi/6
    x_0 = x_max/2 + 1.4*r1*np.sin(phi)
    y_0 = y_max/2 + r1*np.cos(phi)
    R_x_0 = x_max/2 - 600 + 1.4*r*np.sin(phi)
    R_y_0 = y_max/2 + r*np.cos(phi)
    
    ax.text(x_0, y_0, Hello_World[i], fontsize=37, verticalalignment='top', horizontalalignment='left', bbox=props2)
    ax.text(R_x_0, R_y_0, addresse, fontsize=25, verticalalignment='top', horizontalalignment='left', bbox=props1, color="white")   
    i = i + 1

plt.savefig("HelloWorld_Zeiger.png", bbox_inches="tight")

